package engine;

import javax.swing.*;
import java.awt.*;

import static engine.GraphicalInterface.f;

public class MenuPanel {

    private static boolean lancementpartie = false;

    public static boolean isRetourdebut() {
        return retourdebut;
    }

    private static boolean retourdebut = true;
    private JButton button;
    private JButton button1;
    private JButton button2;
    private JButton button3;

    private static  boolean shootingCharacter = false;
    private static  boolean normalCharacter = false;

    public static boolean isShootingCharacter() {
        return shootingCharacter;
    }

    public static boolean isNormalCharacter() {
        return normalCharacter;
    }

    private void resetLancementpartie() {
        button.removeActionListener(e -> lancementpartie = true);
        lancementpartie = false;
    }

    private void resetRetourdebut() {
        button.removeActionListener(e -> retourdebut = true);
        retourdebut = false;
    }

    private void resetCharacter() {
        button1.removeActionListener(e -> shootingCharacter = true);
        button2.removeActionListener(e -> normalCharacter = true);
        shootingCharacter = false;
        normalCharacter = false;
    }

    private Panel gameMenu;
    private Panel gameChoice;
    private Panel gameFin;

    public boolean isLancementpartie() {
        return lancementpartie;
    }



    public MenuPanel(){
        f=new JFrame();
        f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        f.setLayout(new BorderLayout());
        f.setPreferredSize(new Dimension(jeu.Painter.getWidth(), jeu.Painter.getHeight()));

    }
    public void menudebut() {
        gameMenu = new Panel();
        button = new JButton("Nouvelle partie");
        gameMenu.add(button, BorderLayout.CENTER);
        button.addActionListener(e -> lancementpartie = true);
        f.getContentPane().add(gameMenu);
        f.setContentPane(gameMenu);
        f.pack();
        f.setVisible(true);
        f.getContentPane().setFocusable(true);
        while(!isLancementpartie()){
            try {
                Thread.sleep(1);
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            }
        }
        resetLancementpartie();
        resetRetourdebut();
        f.getContentPane().remove(gameMenu);
    }

    public void menuChoice(){
        gameChoice = new Panel();
        button1 = new JButton("Personnage Distance");
        button2 = new JButton("Personnage Melee");
        gameChoice.add(button1,BorderLayout.CENTER);
        gameChoice.add(button2,BorderLayout.CENTER);
        button1.addActionListener(e -> shootingCharacter = true);
        button2.addActionListener(e -> normalCharacter = true);
        f.getContentPane().add(gameChoice);
        f.setContentPane(gameChoice);
        f.pack();
        f.setVisible(true);
        f.getContentPane().setFocusable(true);

        while(!isShootingCharacter() && !isNormalCharacter()){
            try {
                Thread.sleep(1);
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            }
        }
        f.getContentPane().remove(gameChoice);
    }

    public void menufin(){
        resetCharacter();
        gameFin= new Panel(new FlowLayout(FlowLayout.CENTER));
        button3 = new JButton("Ecran debut");
        JLabel label = new JLabel("Game Over");
        label.setFont(new Font("Arial", Font.BOLD, 24));
        label.setForeground(Color.RED);
        gameFin.add(label);
        gameFin.add(button3,BorderLayout.CENTER);
        button3.addActionListener(e -> retourdebut = true);
        f.getContentPane().add(gameFin);
        f.setContentPane(gameFin);
        f.pack();
        f.setVisible(true);
        f.getContentPane().setFocusable(true);
        while(!isRetourdebut()){
            try {
                Thread.sleep(1);
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            }
        }
        f.getContentPane().remove(gameFin);
    }
}
